// T4WDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "T4WDemo.h"
#include "T4WDemoDlg.h"
#include "T4W.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CT4WDemoDlg dialog

CT4WDemoDlg::CT4WDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CT4WDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CT4WDemoDlg)
	m_cbtta = TRUE;
	m_cbttb = TRUE;
	m_cbttc = TRUE;
	m_cbttd = TRUE;
	m_cbactionread = FALSE;
	m_cbactionwrite = FALSE;
	m_rbpw = 0;
	m_rbcomport = -1;
	m_ebUserPW = _T("MIKR");
	m_rbnewpw = 0;
	m_ebNewUserPW = _T("MIKR");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CT4WDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CT4WDemoDlg)
	DDX_Control(pDX, IDC_ST_TAGTYPE, m_stTagType);
	DDX_Control(pDX, IDC_ST_ERROR, m_stError);
	DDX_Control(pDX, IDC_ST_SERNR, m_stSerNr);
	DDX_Control(pDX, IDC_LBLOG, m_lbLog);
	DDX_Control(pDX, IDC_BTSTARTSTOP, m_BtStartStop);
	DDX_Check(pDX, IDC_CBTTA, m_cbtta);
	DDX_Check(pDX, IDC_CBTTB, m_cbttb);
	DDX_Check(pDX, IDC_CBTTC, m_cbttc);
	DDX_Check(pDX, IDC_CBTTD, m_cbttd);
	DDX_Check(pDX, IDC_CBACTIONREAD, m_cbactionread);
	DDX_Check(pDX, IDC_CBACTIONWRITE, m_cbactionwrite);
	DDX_Radio(pDX, IDC_RBPW00, m_rbpw);
	DDX_Radio(pDX, IDC_RBCOM1, m_rbcomport);
	DDX_Text(pDX, IDC_EB_USERPW, m_ebUserPW);
	DDX_Radio(pDX, IDC_RBNEWPW00, m_rbnewpw);
	DDX_Text(pDX, IDC_EB_NEWUSERPW, m_ebNewUserPW);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CT4WDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CT4WDemoDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CBTTA, OnBtTT)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BTSTARTSTOP, OnBtStartStop)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_RBCOM1, OnRbComPort)
	ON_BN_CLICKED(IDC_BT_READALL, OnBtReadAll)
	ON_BN_CLICKED(IDC_BT_SELECT, OnBtSelect)
	ON_BN_CLICKED(IDC_BT_WRITE00, OnBtWrite00)
	ON_BN_CLICKED(IDC_BT_WRITEENUM, OnBtWriteEnum)
	ON_BN_CLICKED(IDC_BT_WRITEFF, OnBtWriteFF)
	ON_BN_CLICKED(IDC_BTWRTAGPW, OnBtWriteTagPW)
	ON_BN_CLICKED(IDC_BT_SELINT, OnBtSelectInternalPW)
	ON_BN_CLICKED(IDC_CBTTB, OnBtTT)
	ON_BN_CLICKED(IDC_CBTTC, OnBtTT)
	ON_BN_CLICKED(IDC_CBTTD, OnBtTT)
	ON_BN_CLICKED(IDC_RBCOM2, OnRbComPort)
	ON_BN_CLICKED(IDC_BT_RDCFG, OnBtReadConfig)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CT4WDemoDlg message handlers

BOOL CT4WDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
   Running = FALSE;
	CurTagType = -1;

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CT4WDemoDlg::OnDestroy() 
{
   int Status = T4DeInit();
	if (Status != T4_NOERROR)
		MessageBeep(MB_OK);

	CDialog::OnDestroy();
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CT4WDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CT4WDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

/**********************************************************/
/***** Debug-Hilfen ***************************************/
/**********************************************************/

void CT4WDemoDlg::Log(BOOL Flush,char *Format,...)
	{
   static BOOL NewLine = TRUE;
   static char SaveBuffer[200];
	va_list	argptr;
	char Buffer[200];

	// Neue Information basteln
	va_start(argptr,Format);
	vsprintf(Buffer,Format,argptr);
	va_end(argptr);

   if (NewLine)
      strcpy(SaveBuffer,"");
   else
      m_lbLog.DeleteString(m_lbLog.GetCount()-1);

   strcat(SaveBuffer,Buffer);
   m_lbLog.InsertString(-1,SaveBuffer);

   NewLine = Flush;

   if (m_lbLog.GetCount() > 50)
      m_lbLog.DeleteString(0);
	m_lbLog.SetCurSel(m_lbLog.GetCount()-1);

   m_lbLog.UpdateWindow();
	}

void CT4WDemoDlg::LogDump(BYTE *Data,DWORD Length)
	{
	Log(TRUE,"%d Byte:",Length);
	for (DWORD i=0; i<Length; i+=8)
		{
		for (int j=0; j<8; j++)
			{
			if (i+j >= Length)
				break;
			Log(FALSE,"%02X ",(int)Data[i+j]);
			}
		}
	Log(TRUE,"");
	}

void CT4WDemoDlg::Start()
{
	GetSystemTimeAsFileTime((FILETIME *)&StartTime);
}

void CT4WDemoDlg::Stop()
{
	GetSystemTimeAsFileTime((FILETIME *)&StopTime);
	DWORD Elapsed = (DWORD)((StopTime - StartTime)/100000);
   Log(TRUE,"Time: %d.%02d seconds",Elapsed / 100, Elapsed % 100);
}

void CT4WDemoDlg::PlotStatus(int Status)
{
   Log(TRUE,"Status: %s",T4GetStatusString(Status));
}

/**********************************************************/
/***** Button-Reaktionen **********************************/
/**********************************************************/

char *CT4WDemoDlg::GetHexString(BYTE *Data,int Length)
{
	static char HexString[500+1];
	char *Dest;

	Dest = HexString;
	for (int i=0; i<Length; i++)
	{
		wsprintf(Dest,"%02X",(int)Data[i]);
		Dest += 2;
		if (i<Length-1)
		{
			strcat(Dest," ");
			Dest++;
		}
	}
   return HexString;
}

BYTE *CT4WDemoDlg::GetPW()
{
	static BYTE Passwords[2][4] =
	{
	   { 0x00,0x00,0x00,0x00 },
	   { 0xFF,0xFF,0xFF,0xFF }
	};
	
	UpdateData(TRUE);
	if (m_rbpw < 0)
		return (BYTE *)Passwords[0];
	if (m_rbpw < 2)
		return (BYTE *)Passwords[m_rbpw];

	static BYTE UserPW[4+1];
	memset(UserPW,0,4);
	memcpy(UserPW,m_ebUserPW.GetBuffer(4),m_ebUserPW.GetLength());
	return (BYTE *)UserPW;
};

BYTE *CT4WDemoDlg::GetNewPW()
{
	static BYTE Passwords[2][4] =
	{
	   { 0x00,0x00,0x00,0x00 },
	   { 0xFF,0xFF,0xFF,0xFF }
	};
	
	UpdateData(TRUE);
	if (m_rbnewpw < 0)
		return (BYTE *)Passwords[0];
	if (m_rbnewpw < 2)
		return (BYTE *)Passwords[m_rbnewpw];

	static BYTE UserPW[4+1];
	memset(UserPW,0,4);
	memcpy(UserPW,m_ebNewUserPW.GetBuffer(4),m_ebNewUserPW.GetLength());
	return (BYTE *)UserPW;
};

/**********************************************************/

void CT4WDemoDlg::OnBtStartStop() 
{
   if (Running)
   {
      m_BtStartStop.SetWindowText("Start (Stopped)");

      T4DeInitTagPoll();
      KillTimer(1);
		Log(TRUE,"Stopped continuous read");
   }
   else
   {
		m_lbLog.ResetContent();
		Log(TRUE,"Start continuous read");
      
		m_BtStartStop.SetWindowText("Stop (Running)");

      UpdateData(TRUE);
		T4InitTagPoll(GetPW());
      SetTimer(1,100,NULL);
   }
	
   Running = !Running;
}

void CT4WDemoDlg::OnTimer(UINT nIDEvent) 
{
	CDialog::OnTimer(nIDEvent);

	static __int64 LastFail;

   if (nIDEvent != 1)
      return;

   if (!Running)
      return;

   UpdateData(TRUE);

   int Status;
   BYTE TagType;
   BYTE IDData[5];
   BYTE RdData[16];
   BYTE WrData[16];

	Status = T4DoTagPoll(&TagType,IDData);
	if (Status != T4_NOERROR)
	{
		GetSystemTimeAsFileTime((FILETIME *)&LastFail);
		if (Status == T4_NOTINIT)
			OnBtStartStop();

		if (Status != T4_NOTAG && Status != T4_CMDNOTAVAILABLE)
			PlotStatus(Status);
      return;
	}

	while (Status == T4_NOERROR)
	{
      Log(TRUE,"Serial Number: %s",GetHexString(IDData,5));
      if (m_cbactionread)
      {
		   Log(FALSE,"Lesen: ");
         Status = T4ReadData(0,4,RdData);
		   Log(TRUE,"%s",T4GetStatusString(Status));
         if (Status == T4_NOERROR)
         {
            LogDump(RdData,16);

            if (m_cbactionwrite)
            {
			      memcpy(WrData,"This is a test!",16); // This string takes 16 bytes (incl. nul)
				   Log(FALSE,"Schreiben: ");
               Status = T4WriteData(0,4,WrData);
				   Log(TRUE,"%s",T4GetStatusString(Status));
               if (Status == T4_NOERROR)
                  return;
            }
         }
      }
		
		T4Halt();
		Status = T4SelectTag(&TagType,IDData);
	}

	__int64 LastSuccess;
	GetSystemTimeAsFileTime((FILETIME *)&LastSuccess);
	DWORD Elapsed = (DWORD)((LastSuccess - LastFail)/100000);
   Log(TRUE,"Time: %d.%02d seconds",Elapsed / 100, Elapsed % 100);

	MessageBeep(MB_OK);
}

void CT4WDemoDlg::OnBtTT() 
{
   UpdateData(TRUE);

   BYTE Driver = 0x00;

   if (m_cbtta)
      Driver |= T4_MSK_IDRO_A;
   if (m_cbttb)
      Driver |= T4_MSK_IDRW_B;
   if (m_cbttc)
      Driver |= T4_MSK_IDRW_C;
   if (m_cbttd)
      Driver |= T4_MSK_IDRW_D;
   
   Log(FALSE,"T4SetTagDriver: ");
	PlotStatus(T4SetTagDriver(Driver));
}

void CT4WDemoDlg::OnRbComPort() 
{
	if (Running)
		OnBtStartStop();
	T4DeInit();

	UpdateData(TRUE);

	char ComPortString[20+1];
	sprintf(ComPortString,"COM%d:",m_rbcomport+1);
   Log(FALSE,"T4Init (%s): ",ComPortString);
	PlotStatus(T4Init(ComPortString));

   // Set the transponder types
   OnBtTT();
}

void CT4WDemoDlg::OnBtSelect() 
{
   int Status;
   BYTE TagType;
   BYTE IDData[5];

	Log(TRUE,"Selecting Tag (PW: %s):",GetHexString(GetPW(),4));
	Start();
	Status = T4SelectTagPW(GetPW(),&TagType,IDData);
	Stop();
	m_stError.SetWindowText(T4GetStatusString(Status));

	if (Status == T4_NOERROR || Status == T4_WRONGTAGPW)
	{
	   MessageBeep(MB_OK);
		switch (TagType)
		{
		case T4_TYPE_IDRO_A:
			m_stTagType.SetWindowText(CString("IDRO-A"));
			m_stSerNr.SetWindowText(GetHexString(IDData,5));
			break;
		case T4_TYPE_IDRW_B:
			m_stTagType.SetWindowText("IDRW-B");
			m_stSerNr.SetWindowText(GetHexString(IDData+1,4));
			break;
		case T4_TYPE_IDRW_C:
			m_stTagType.SetWindowText("IDRW-C");
			m_stSerNr.SetWindowText(GetHexString(IDData+1,4));
			break;
		case T4_TYPE_IDRW_D:
			m_stTagType.SetWindowText("IDRW-D");
			m_stSerNr.SetWindowText(GetHexString(IDData+1,4));
			break;
		default:
			m_stTagType.SetWindowText("Unknown");
			m_stSerNr.SetWindowText("Unknown");
			break;
		}
	}
   if (Status != T4_NOERROR)
	{
	   MessageBeep(MB_ICONASTERISK);
		m_stTagType.SetWindowText("None");
		m_stSerNr.SetWindowText("Unknown");
		CurTagType = -1;
      return;
	}
	CurTagType = TagType;
}

void CT4WDemoDlg::OnBtSelectInternalPW() 
{
   int Status;
   BYTE TagType;
   BYTE IDData[5];

	Log(TRUE,"Selecting Tag with Reader Password:");
	Start();
	Status = T4SelectTagPW(NULL,&TagType,IDData);
	Stop();
	m_stError.SetWindowText(T4GetStatusString(Status));

	if (Status == T4_NOERROR || Status == T4_WRONGTAGPW)
	{
	   MessageBeep(MB_OK);
		switch (TagType)
		{
		case T4_TYPE_IDRO_A:
			m_stTagType.SetWindowText(CString("IDRO-A"));
			m_stSerNr.SetWindowText(GetHexString(IDData,5));
			break;
		case T4_TYPE_IDRW_B:
			m_stTagType.SetWindowText("IDRW-B");
			m_stSerNr.SetWindowText(GetHexString(IDData+1,4));
			break;
		case T4_TYPE_IDRW_C:
			m_stTagType.SetWindowText("IDRW-C");
			m_stSerNr.SetWindowText(GetHexString(IDData+1,4));
			break;
		case T4_TYPE_IDRW_D:
			m_stTagType.SetWindowText("IDRW-D");
			m_stSerNr.SetWindowText(GetHexString(IDData+1,4));
			break;
		default:
			m_stTagType.SetWindowText("Unknown");
			m_stSerNr.SetWindowText("Unknown");
			break;
		}
	}
   if (Status != T4_NOERROR)
	{
	   MessageBeep(MB_ICONASTERISK);
		m_stTagType.SetWindowText("None");
		m_stSerNr.SetWindowText("Unknown");
		CurTagType = -1;
      return;
	}
	CurTagType = TagType;
}

void CT4WDemoDlg::OnBtReadAll() 
{
	OnBtSelect();

   int Status;
	BYTE UserSize;
	BYTE UserData[4*44];

	switch (CurTagType)
	{
	case T4_TYPE_IDRO_A:
	   Log(TRUE,"R/O tag has no data space!");
		return;
	case T4_TYPE_IDRW_B:
		UserSize = 44;
		break;
	case T4_TYPE_IDRW_C:
		UserSize = 4;
		break;
	case T4_TYPE_IDRW_D:
		UserSize = 25;
		break;
	default:
	   Log(TRUE,"No tag given!");
		return;
	}

	Start();
	Log(TRUE,"Reading:");
	for (BYTE Adr = 0; Adr < UserSize; Adr += 4)
	{
		BYTE WordCnt = 4;
		if (UserSize - Adr < 4)
			WordCnt = UserSize-Adr;

		Status = T4ReadData(Adr,WordCnt,&UserData[Adr*4]);
      if (Status != T4_NOERROR)
			break;
	   Log(TRUE,"%02X: %s",(int)Adr,GetHexString(&UserData[Adr*4],WordCnt*4));
	}
   Log(TRUE,"%s",T4GetStatusString(Status));
	Stop();
}

#define WR_00		0
#define WR_FF		1
#define WR_ENUM	2

void CT4WDemoDlg::WriteAll(int What)
{
	OnBtSelect();

   int Status;
	BYTE UserSize;
	BYTE UserData[4*44];

	switch (CurTagType)
	{
	case T4_TYPE_IDRO_A:
	   Log(TRUE,"R/O tag has no data space!");
		return;
	case T4_TYPE_IDRW_B:
		UserSize = 44;
		break;
	case T4_TYPE_IDRW_C:
		UserSize = 4;
		break;
	case T4_TYPE_IDRW_D:
		UserSize = 25;
		break;
	default:
	   Log(TRUE,"No tag given!");
		return;
	}

	switch (What)
	{
	case WR_00:
		memset(UserData,0x00,UserSize*4);
		break;
	case WR_FF:
		memset(UserData,0xFF,UserSize*4);
		break;
	case WR_ENUM:
		for (int i=0; i<UserSize*4; i++)
			UserData[i] = i;
		break;
	}

	Start();
   Log(TRUE,"Writing:");
	for (BYTE Adr = 0; Adr < UserSize; Adr += 4)
	{
		BYTE WordCnt = 4;
		if (UserSize - Adr < 4)
			WordCnt = UserSize-Adr;

		Status = T4WriteData(Adr,WordCnt,&UserData[Adr*4]);
      if (Status != T4_NOERROR)
			break;
	}
   Log(TRUE,"%s",T4GetStatusString(Status));
	Stop();
}

void CT4WDemoDlg::OnBtWrite00() 
{
	WriteAll(WR_00);
}

void CT4WDemoDlg::OnBtWriteFF() 
{
	WriteAll(WR_FF);
}

void CT4WDemoDlg::OnBtWriteEnum() 
{
	WriteAll(WR_ENUM);
}

void CT4WDemoDlg::OnBtWriteTagPW() 
{
	OnBtSelect();

	BYTE PWAdr;

	switch (CurTagType)
	{
	case T4_TYPE_IDRO_A:
	   Log(TRUE,"IDRO-A has no password!");
		return;
	case T4_TYPE_IDRW_B:
	   Log(TRUE,"IDRW-B has no password!");
		return;
	case T4_TYPE_IDRW_C:
		PWAdr = 1;
		break;
	case T4_TYPE_IDRW_D:
		PWAdr = 2;
		break;
	default:
	   Log(TRUE,"No tag given!");
		return;
	}

	char OldPW[20+1];
	char NewPW[20+1];
	strcpy(OldPW,GetHexString(GetPW(),4));
	strcpy(NewPW,GetHexString(GetNewPW(),4));
   Log(TRUE,"Changing Tag PW (%s -> %s):",OldPW,NewPW);
	PlotStatus(T4WriteConfigData(PWAdr,GetNewPW()));
}

void CT4WDemoDlg::OnBtReadConfig() 
{
	OnBtSelect();

   int Status;
	BYTE ConfigSize;

	switch (CurTagType)
	{
	case T4_TYPE_IDRO_A:
	   Log(TRUE,"R/O tag has no config space!");
		return;
	case T4_TYPE_IDRW_B:
		ConfigSize = 7;   // But: Adr 1..6 are W/O (Adresserror)
		break;
	case T4_TYPE_IDRW_C:
		ConfigSize = 3;
		break;
	case T4_TYPE_IDRW_D:
		ConfigSize = 4;
		break;
	default:
	   Log(TRUE,"No tag given!");
		return;
	}

	Start();
	Log(TRUE,"Reading Config:");
	for (BYTE ConfigAdr = 0; ConfigAdr < ConfigSize; ConfigAdr ++)
	{
		BYTE ConfigWord[5];

		Status = T4ReadConfigData(ConfigAdr,ConfigWord);
      if (Status != T4_NOERROR && Status != T4_ADRESSERROR)
			break;
		if (Status == T4_NOERROR)
			Log(TRUE,"%d: %02X  %s",(int)ConfigAdr,(int)ConfigWord[0],GetHexString(&ConfigWord[1],4));
		else
			// Adresserror
			Log(TRUE,"%d: W/O",(int)ConfigAdr);
	}
   Log(TRUE,"%s",T4GetStatusString(Status));
	Stop();
}

